TEST_CONFIG ?=../config.test.json
TEST_EXCLUDED_PARTS ?= kredis
DEPLOYDIR_CGI ?=../cgi
DEPLOYDIR_UTILS ?=../utils

TARGETS_CGI=requestoauthurl oauthcallback refreshlogin certifykey
TARGETS_UTILS=test-util admin-util

MACROS = -D_POSIX_C_SOURCE=200809L # needed for strdup and popen
CFLAGS ?= -std=c99 -fPIC -O2 -pedantic -pedantic-errors -Wall -Wextra  -W -Wstrict-prototypes -Wwrite-strings -Wno-missing-field-initializers -Werror -Wshadow -Winit-self -Wcast-align -Wformat=2 -Wmissing-prototypes -Wstrict-overflow=2 -Wcast-qual -Wundef $(MACROS) -fstack-protector -g -I.  $(shell curl-config --cflags) 
#CFLAGS ?= -std=c99 -fPIC -O2 -pedantic -pedantic-errors -Wall -Wextra  -W -Wstrict-prototypes -Wwrite-strings -Wno-missing-field-initializers -Werror -Wshadow -Winit-self -Wcast-align -Wformat=2 -Wmissing-prototypes -Wstrict-overflow=2 -Wcast-qual -Wundef -fstack-protector -flto  -g -I.  $(shell curl-config --cflags) 
CC ?= gcc
LDLIBS = -lcrypto -lm $(shell curl-config --libs) -l:libcjson.a -l:libhiredis.a -l:libb64.a
#LDFLAGS = -L../cJSON/ -L../hiredis -L../libb64/src/ -Wl,--as-needed
LDFLAGS = -L../cJSON/ -L../hiredis -L../libb64/src/
OBJS=cgi.o common.o db.o kredis.o oauth.o jwt.o config.o user.o template_engine.o oidc.o

TARGETS=$(OBJS) $(TARGETS_CGI) $(TARGETS_UTILS)


# Test for missing binaries
EXECUTABLES = curl-config $(CC) bash 
K := $(foreach exec,$(EXECUTABLES),\
	$(if $(shell which $(exec)),some string,$(error "No $(exec) in PATH")))

define DEPLOY
cp -vf "$(1)" "$(2)";
endef

.PHONY: default
#default: build deploy
default: build test deploy

.PHONY: all
all: build test deploy

.PHONY: build
build: $(TARGETS) cgi utils

.PHONY: cgi
cgi: $(OBJS) $(TARGETS_CGI)

.PHONY: utils
utils: $(OBJS) $(TARGETS_UTILS)

.PHONY: test
test: utils
	# tests all parts except for kredis
	./test-util -a -c $(TEST_CONFIG) $(TEST_EXCLUDED_PARTS)
	#./test-util -a -c $(TEST_CONFIG)

.PHONY: tests
tests: test

.PHONY: clean
clean:
	$(RM) *.o *.so* *.a
	$(RM) $(TARGETS)

.PHONY: deploy
deploy: deploy_cgi deploy_utils

.PHONY: deploy_cgi
deploy_cgi: cgi
	@echo "=> Deploying CGI..."
	$(foreach target,$(TARGETS_CGI),$(call DEPLOY,$(target),$(DEPLOYDIR_CGI)/))
	@echo "=> Finished deploying CGI."

.PHONY: deploy_utils
deploy_utils: utils
	@echo "=> Deploying UTILS..."
	$(foreach target,$(TARGETS_UTILS),$(call DEPLOY,$(target),$(DEPLOYDIR_UTILS)/sshca-$(target)))
	@echo "=> Finished deploying UTILS."

# Compile code

%: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(OBJS) $(LOADLIBES) $(LDLIBS) -o $@

#%: %.o
#	$(CC) $(LDFLAGS) $(TARGET_ARCH)  $^ $(OBJS) $(LOADLIBES) $(LDLIBS) -o $@
